package com.remobjects.elements.system;

import java.lang.reflect.Method;

public class AWTThreadSyncHelper implements IThreadSyncHelper {
    private Class fType;
    private Method finvokeLater;
    private Method fisDispatchThread;

    public AWTThreadSyncHelper() {
        this.fType = AWTThreadSyncHelper.class.getClassLoader().loadClass("java.awt.EventQueue");
        this.fisDispatchThread = this.fType.getMethod("isDispatchThread", new Class[0]);
        this.finvokeLater = this.fType.getMethod("invokeLater", new Class[]{Runnable.class});
    }

    public Object GetThreadContext() {
        return ((Boolean) this.fisDispatchThread.invoke(null, new Object[0])).booleanValue() ? this : null;
    }

    public void SyncBack(Object obj, Runnable runnable) {
        this.finvokeLater.invoke(runnable, new Object[0]);
    }
}
