package com.remobjects.elements.system;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

public class AndroidThreadSyncHelper implements IThreadSyncHelper {
    private Constructor fHandlerCtor;
    private Method fHandlerPost;
    private Method fMyLooper;

    public AndroidThreadSyncHelper() {
        this.fMyLooper = AndroidThreadSyncHelper.class.getClassLoader().loadClass("android.os.Looper").getMethod("myLooper", new Class[0]);
        Class loadClass = AndroidThreadSyncHelper.class.getClassLoader().loadClass("android.os.Handler");
        this.fHandlerCtor = loadClass.getConstructor(new Class[]{r0});
        this.fHandlerPost = loadClass.getMethod("post", new Class[]{Runnable.class});
    }

    public Object GetThreadContext() {
        return this.fMyLooper.invoke(null, new Object[0]);
    }

    public void SyncBack(Object obj, Runnable runnable) {
        this.fHandlerPost.invoke(this.fHandlerCtor.newInstance(new Object[]{obj}), new Object[]{runnable});
    }
}
