package com.remobjects.elements.system;

import java.util.concurrent.Callable;

public abstract class FutureHelper {
    protected FutureHelper() {
    }

    public static <T> Task1<T> Execute(Callable<T> callable) {
        Task nonThreadedTask1 = new NonThreadedTask1((Callable) callable, null);
        nonThreadedTask1.Start(null);
        return nonThreadedTask1;
    }

    public static Task Execute(Runnable runnable) {
        Task nonThreadedTask = new NonThreadedTask(runnable, null);
        nonThreadedTask.Start(null);
        return nonThreadedTask;
    }

    public static <T> Task1<T> ExecuteAsync(Callable<T> callable, boolean z) {
        Task task1 = new Task1((Callable) callable, null);
        task1.Start(null);
        return task1;
    }

    public static Task ExecuteAsync(Runnable runnable, boolean z) {
        Task task = new Task(runnable, null);
        task.Start(null);
        return task;
    }

    public static <T> boolean IsDone(Task1<T> task1) {
        return task1.getIsCompleted();
    }

    public static boolean IsDone(Task task) {
        return task.getIsCompleted();
    }
}
