package com.remobjects.elements.system;

import java.util.concurrent.Executor;

public class NonThreadedTask extends Task {
    NonThreadedTask(Object obj, Object obj2) {
        super(obj, obj2);
    }

    public NonThreadedTask(Runnable runnable, Object obj) {
        super(runnable, obj);
    }

    public void Start(Executor executor) {
        Object obj = 1;
        synchronized (this.fLock) {
            Throwable th = null;
            try {
                if (this.fState == 0) {
                    obj = null;
                }
                if (obj != null) {
                    throw new IllegalStateException("Task already started/queued/done");
                }
                this.fState = 1;
            } catch (Throwable th2) {
                th = th2;
            }
        }
        if (th != null) {
            throw th;
        }
    }

    public void Wait() {
        Throwable th;
        Object obj = null;
        Object obj2 = 1;
        synchronized (this) {
            try {
                if ((this.fState == 1 ? 1 : null) != null) {
                    this.fState = 2;
                } else {
                    obj2 = null;
                }
                obj = obj2;
                th = null;
            } catch (Throwable th2) {
                th = th2;
            }
        }
        if (th != null) {
            throw th;
        }
        if (obj != null) {
            run();
        }
        super.Wait();
    }

    public boolean Wait(int i) {
        Throwable th;
        Object obj = null;
        Object obj2 = 1;
        synchronized (this) {
            try {
                if ((this.fState == 1 ? 1 : null) != null) {
                    this.fState = 2;
                } else {
                    obj2 = null;
                }
                obj = obj2;
                th = null;
            } catch (Throwable th2) {
                th = th2;
            }
        }
        if (th != null) {
            throw th;
        }
        if (obj != null) {
            run();
        }
        return super.Wait(i);
    }
}
