package com.remobjects.elements.system;

public class TaskCompletionSource<T> {
    private Task1<T> fTask;

    public TaskCompletionSource(Object obj) {
        this.fTask = new TaskCompletionSourceTask(null, obj);
        this.fTask.fState = 2;
    }

    public void SetException(Throwable th) {
        synchronized (this.fTask.fLock) {
            Throwable th2 = null;
            try {
                if ((this.fTask.fState == 3 ? 1 : null) != null) {
                    throw new IllegalStateException("Task already done");
                }
                this.fTask.fException = th;
                this.fTask.fState = 3;
            } catch (Throwable th3) {
                th2 = th3;
            }
        }
        if (th2 != null) {
            throw th2;
        }
        this.fTask.Done(th);
    }

    public void SetResult(T t) {
        Throwable th;
        synchronized (this.fTask.fLock) {
            try {
                if ((this.fTask.fState == 3 ? 1 : null) != null) {
                    throw new IllegalStateException("Task already done");
                }
                this.fTask.fResult = t;
                this.fTask.fState = 3;
                th = null;
            } catch (Throwable th2) {
                th = th2;
            }
        }
        if (th != null) {
            throw th;
        }
        this.fTask.Done(null);
    }

    public Task1<T> getTask() {
        return this.fTask;
    }
}
