package com.remobjects.elements.system;

public final class UnsignedByte extends Number implements Comparable<UnsignedByte> {
    private static final short MASK = (short) 255;
    public static final byte MAX_VALUE = (byte) -1;
    public static final byte MIN_VALUE = (byte) 0;
    private byte fValue;

    public UnsignedByte(byte b) {
        this.fValue = (byte) b;
    }

    public UnsignedByte(String str) {
        this.fValue = (byte) parseByte(str, 10);
    }

    private static short ToShort(byte b) {
        return (short) (b & 255);
    }

    public static byte doubleToUnsigned(double d) {
        return ((d > 127.0d ? 1 : (d == 127.0d ? 0 : -1)) > 0 ? 1 : null) != null ? (byte) ((int) (d - 256.0d)) : (byte) ((int) d);
    }

    public static byte floatToUnsigned(float f) {
        return ((f > 127.0f ? 1 : (f == 127.0f ? 0 : -1)) > 0 ? 1 : null) != null ? (byte) ((int) (f - 256.0f)) : (byte) ((int) f);
    }

    public static byte parseByte(String str) {
        return parseByte(str, 10);
    }

    public static byte parseByte(String str, int i) {
        Object obj = 1;
        if ((str == null ? 1 : null) != null) {
            throw new NullPointerException();
        }
        short parseShort = Short.parseShort(str, i);
        if ((parseShort & 255) == parseShort) {
            obj = null;
        }
        if (obj == null) {
            return (byte) parseShort;
        }
        throw new NumberFormatException(str == null ? "For input string: " : "For input string: ".concat(str));
    }

    public static String toString(byte b) {
        return Short.toString((short) ToShort((byte) b));
    }

    public static byte unsignedDivide(byte b, byte b2) {
        return (byte) (ToShort((byte) b) / ToShort((byte) b2));
    }

    public static byte unsignedRemainder(byte b, byte b2) {
        return (byte) (ToShort((byte) b) % ToShort((byte) b2));
    }

    public static double unsignedToDouble(byte b) {
        return (b < null ? 256.0d : 0.0d) + ((double) b);
    }

    public static float unsignedToFloat(byte b) {
        return (b < null ? 256.0f : 0.0f) + ((float) b);
    }

    public static UnsignedByte valueOf(byte b) {
        return new UnsignedByte((byte) b);
    }

    public byte byteValue() {
        return this.fValue;
    }

    public int compareTo(UnsignedByte unsignedByte) {
        if ((unsignedByte == null ? 1 : null) == null) {
            return Byte.compare((byte) ((byte) (this.fValue - 128)), (byte) ((byte) (unsignedByte.fValue - 128)));
        }
        throw new NullPointerException();
    }

    public double doubleValue() {
        return unsignedToDouble((byte) this.fValue);
    }

    public boolean equals(Object obj) {
        UnsignedByte unsignedByte = !(obj instanceof UnsignedByte) ? null : (UnsignedByte) obj;
        return unsignedByte != null && unsignedByte.fValue == this.fValue;
    }

    public float floatValue() {
        return unsignedToFloat((byte) this.fValue);
    }

    public int hashCode() {
        return this.fValue;
    }

    public int intValue() {
        return ToShort((byte) this.fValue);
    }

    public long longValue() {
        return (long) ToShort((byte) this.fValue);
    }

    public short shortValue() {
        return ToShort((byte) this.fValue);
    }

    public String toString() {
        return toString((byte) this.fValue);
    }
}
