package com.remobjects.elements.system;

import swift.__Extension_Int3217;

public final class UnsignedInteger extends Number implements Comparable<UnsignedInteger> {
    private static final long MASK = 4294967295L;
    public static final int MAX_VALUE = -1;
    public static final int MIN_VALUE = 0;
    private int fValue;

    public UnsignedInteger(int i) {
        this.fValue = i;
    }

    public UnsignedInteger(String str) {
        this.fValue = parseInt(str, 10);
    }

    private static long ToLong(int i) {
        return ((long) i) & MASK;
    }

    public static int doubleToUnsigned(double d) {
        return ((d > 2.147483647E9d ? 1 : (d == 2.147483647E9d ? 0 : -1)) > 0 ? 1 : null) != null ? (int) (d - 4.294967296E9d) : (int) d;
    }

    public static int floatToUnsigned(float f) {
        return ((f > 2.14748365E9f ? 1 : (f == 2.14748365E9f ? 0 : -1)) > 0 ? 1 : null) != null ? (int) (f - 4.2949673E9f) : (int) f;
    }

    public static int parseInt(String str) {
        return parseInt(str, 10);
    }

    public static int parseInt(String str, int i) {
        Object obj = 1;
        if ((str == null ? 1 : null) != null) {
            throw new NullPointerException();
        }
        long parseLong = Long.parseLong(str, i);
        if ((MASK & parseLong) == parseLong) {
            obj = null;
        }
        if (obj == null) {
            return (int) parseLong;
        }
        throw new NumberFormatException(str == null ? "For input string: " : "For input string: ".concat(str));
    }

    public static String toBinaryString(int i) {
        return toString(i, 2);
    }

    public static String toHexString(int i) {
        return toString(i, 16);
    }

    public static String toOctalString(int i) {
        return toString(i, 8);
    }

    public static String toString(int i) {
        return toString(i, 10);
    }

    public static String toString(int i, int i2) {
        return Long.toString(ToLong(i), i2);
    }

    public static int unsignedDivide(int i, int i2) {
        return (int) (ToLong(i) / ToLong(i2));
    }

    public static int unsignedRemainder(int i, int i2) {
        return (int) (ToLong(i) % ToLong(i2));
    }

    public static double unsignedToDouble(int i) {
        return (i < 0 ? 4.294967296E9d : 0.0d) + ((double) i);
    }

    public static float unsignedToFloat(int i) {
        return (i < 0 ? 4.2949673E9f : 0.0f) + ((float) i);
    }

    public static UnsignedInteger valueOf(int i) {
        return new UnsignedInteger(i);
    }

    public byte byteValue() {
        return (byte) this.fValue;
    }

    public int compareTo(UnsignedInteger unsignedInteger) {
        if ((unsignedInteger == null ? 1 : null) == null) {
            return Integer.compare(this.fValue + __Extension_Int3217.min, unsignedInteger.fValue + __Extension_Int3217.min);
        }
        throw new NullPointerException();
    }

    public double doubleValue() {
        return unsignedToDouble(this.fValue);
    }

    public boolean equals(Object obj) {
        UnsignedInteger unsignedInteger = !(obj instanceof UnsignedInteger) ? null : (UnsignedInteger) obj;
        return unsignedInteger != null && unsignedInteger.fValue == this.fValue;
    }

    public float floatValue() {
        return unsignedToFloat(this.fValue);
    }

    public int hashCode() {
        return this.fValue;
    }

    public int intValue() {
        return this.fValue;
    }

    public long longValue() {
        return ToLong(this.fValue);
    }

    public short shortValue() {
        return (short) this.fValue;
    }

    public String toString() {
        return toString(this.fValue);
    }
}
