package com.remobjects.elements.system;

public final class UnsignedShort extends Number implements Comparable<UnsignedShort> {
    private static final int MASK = 65535;
    public static final short MAX_VALUE = (short) -1;
    public static final short MIN_VALUE = (short) 0;
    private short fValue;

    public UnsignedShort(String str) {
        this.fValue = (short) parseShort(str, 10);
    }

    public UnsignedShort(short s) {
        this.fValue = (short) s;
    }

    private static int ToInt(short s) {
        return MASK & s;
    }

    public static short doubleToUnsigned(double d) {
        return ((d > 32767.0d ? 1 : (d == 32767.0d ? 0 : -1)) > 0 ? 1 : null) != null ? (short) ((int) (d - 65536.0d)) : (short) ((int) d);
    }

    public static short floatToUnsigned(float f) {
        return ((f > 32767.0f ? 1 : (f == 32767.0f ? 0 : -1)) > 0 ? 1 : null) != null ? (short) ((int) (f - 65536.0f)) : (short) ((int) f);
    }

    public static short parseShort(String str) {
        return parseShort(str, 10);
    }

    public static short parseShort(String str, int i) {
        Object obj = 1;
        if ((str == null ? 1 : null) != null) {
            throw new NullPointerException();
        }
        int parseInt = Integer.parseInt(str, i);
        if ((MASK & parseInt) == parseInt) {
            obj = null;
        }
        if (obj == null) {
            return (short) parseInt;
        }
        throw new NumberFormatException(str == null ? "For input string: " : "For input string: ".concat(str));
    }

    public static String toString(short s) {
        return Integer.toString(ToInt((short) s));
    }

    public static short unsignedDivide(short s, short s2) {
        return (short) (ToInt((short) s) / ToInt((short) s2));
    }

    public static short unsignedRemainder(short s, short s2) {
        return (short) (ToInt((short) s) % ToInt((short) s2));
    }

    public static double unsignedToDouble(short s) {
        return (s < (short) 0 ? 65536.0d : 0.0d) + ((double) s);
    }

    public static float unsignedToFloat(short s) {
        return (s < (short) 0 ? 65536.0f : 0.0f) + ((float) s);
    }

    public static UnsignedShort valueOf(short s) {
        return new UnsignedShort((short) s);
    }

    public byte byteValue() {
        return (byte) this.fValue;
    }

    public int compareTo(UnsignedShort unsignedShort) {
        if ((unsignedShort == null ? 1 : null) == null) {
            return Short.compare((short) ((short) (this.fValue - 32768)), (short) ((short) (unsignedShort.fValue - 32768)));
        }
        throw new NullPointerException();
    }

    public double doubleValue() {
        return unsignedToDouble((short) this.fValue);
    }

    public boolean equals(Object obj) {
        UnsignedShort unsignedShort = !(obj instanceof UnsignedShort) ? null : (UnsignedShort) obj;
        return unsignedShort != null && unsignedShort.fValue == this.fValue;
    }

    public float floatValue() {
        return unsignedToFloat((short) this.fValue);
    }

    public int hashCode() {
        return this.fValue;
    }

    public int intValue() {
        return ToInt((short) this.fValue);
    }

    public long longValue() {
        return (long) ToInt((short) this.fValue);
    }

    public short shortValue() {
        return this.fValue;
    }

    public String toString() {
        return toString((short) this.fValue);
    }
}
