package com.remobjects.elements.linq;

import java.io.Closeable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;

public abstract class __Extensions {

    /* renamed from: com.remobjects.elements.linq.__Extensions.11 */
    private final class AnonymousClass11<T, C extends Comparable<T>> implements Comparator<T> {
        private final AnonymousClass10<T, C> arg0;

        public AnonymousClass11(AnonymousClass10<T, C> anonymousClass10) {
            this.arg0 = anonymousClass10;
        }

        public final /* synthetic */ int compare(T t, T t2) {
            return this.arg0.$OrderBy$b__0((Object) t, (Object) t2);
        }

        public final /* synthetic */ boolean equals(Object obj) {
            return false;
        }
    }

    /* renamed from: com.remobjects.elements.linq.__Extensions.13 */
    private final class AnonymousClass13<T, C extends Comparable<T>> implements Comparator<T> {
        private final AnonymousClass12<T, C> arg0;

        public AnonymousClass13(AnonymousClass12<T, C> anonymousClass12) {
            this.arg0 = anonymousClass12;
        }

        public final /* synthetic */ int compare(T t, T t2) {
            return this.arg0.$OrderByDescending$b__0((Object) t, (Object) t2);
        }

        public final /* synthetic */ boolean equals(Object obj) {
            return false;
        }
    }

    protected __Extensions() {
    }

    public static <T> boolean Any(Iterable<T> iterable) {
        return iterable.iterator().hasNext();
    }

    public static <T> boolean Any(Iterable<T> iterable, Predicate<T> predicate) {
        int i;
        Closeable closeable = null;
        boolean z = true;
        Object obj = null;
        if (iterable != null) {
            Iterator it = iterable.iterator();
            if (it != null) {
                Closeable closeable2;
                do {
                    try {
                        if (!it.hasNext()) {
                            z = false;
                            i = -1;
                            closeable2 = null;
                            break;
                        }
                    } catch (Throwable th) {
                        i = -1;
                        Object obj2 = th;
                        z = false;
                    }
                } while (!predicate.Invoke(it.next()));
                closeable2 = null;
                if (it instanceof Closeable) {
                    if (it instanceof Closeable) {
                        closeable = (Closeable) it;
                    }
                    closeable.close();
                }
                switch (obj) {
                    case TaskState.Created /*0*/:
                        return z;
                    default:
                        if (closeable2 == null) {
                            return z;
                        }
                        throw closeable2;
                }
            }
        }
        return false;
    }

    public static <T> Iterable<T> Concat(Iterable<T> iterable, Iterable<T> iterable2) {
        return new __Extensions$$Concat$d__6(iterable, iterable2);
    }

    public static <T> boolean Contains(List<T> list, T t, Comparer<T> comparer) {
        if (comparer == null) {
            return list.contains(t);
        }
        int Count = Count(list) - 1;
        if (!(0 <= Count)) {
            return false;
        }
        int i = Count + 1;
        int i2 = 0;
        do {
            if (comparer.Invoke(list.get(i2), t) == 0) {
                return true;
            }
            i2++;
        } while (i2 != i);
        return false;
    }

    public static <T> int Count(Iterable<T> iterable) {
        Object obj = 1;
        Closeable closeable = null;
        if (iterable instanceof List) {
            return (!(iterable instanceof List) ? null : (List) iterable).size();
        }
        if ((iterable != null ? 1 : null) != null) {
            Iterator it = iterable.iterator();
            if (it == null) {
                obj = null;
            }
            if (obj != null) {
                Throwable th;
                int i = 0;
                while (it.hasNext()) {
                    try {
                        it.next();
                        i++;
                    } catch (Throwable th2) {
                        th = th2;
                    }
                }
                th = null;
                if (it instanceof Closeable) {
                    if (it instanceof Closeable) {
                        closeable = (Closeable) it;
                    }
                    closeable.close();
                }
                if (th == null) {
                    return i;
                }
                throw th;
            }
        }
        return 0;
    }

    public static <T> Iterable<T> Distinct(Iterable<T> iterable, Comparer<T> comparer) {
        Closeable closeable = null;
        Iterable<T> arrayList = new ArrayList();
        Iterator it;
        Object next;
        Throwable th;
        if ((comparer == null ? 1 : null) != null) {
            if ((iterable != null ? 1 : null) != null) {
                it = iterable.iterator();
                if ((it != null ? 1 : null) != null) {
                    while (it.hasNext()) {
                        try {
                            next = it.next();
                            if ((!arrayList.contains(next) ? 1 : null) != null) {
                                arrayList.add(next);
                            }
                        } catch (Throwable th2) {
                            th = th2;
                        }
                    }
                    th = null;
                    if (it instanceof Closeable) {
                        if (it instanceof Closeable) {
                            closeable = (Closeable) it;
                        }
                        closeable.close();
                    }
                    if (th != null) {
                        throw th;
                    }
                }
            }
        }
        if ((iterable != null ? 1 : null) != null) {
            it = iterable.iterator();
            if ((it != null ? 1 : null) != null) {
                while (it.hasNext()) {
                    try {
                        next = it.next();
                        if (((Contains(arrayList, next, comparer) ? 1 : null) == null ? 1 : null) != null) {
                            arrayList.add(next);
                        }
                    } catch (Throwable th3) {
                        th = th3;
                    }
                }
                th = null;
                if (it instanceof Closeable) {
                    if (it instanceof Closeable) {
                        closeable = (Closeable) it;
                    }
                    closeable.close();
                }
                if (th != null) {
                    throw th;
                }
            }
        }
        return arrayList;
    }

    public static <T> Iterable<T> Except(Iterable<T> iterable, Iterable<T> iterable2, Comparer<T> comparer) {
        return new __Extensions$$Except$d__8(iterable, iterable2, comparer);
    }

    public static <T> T FirstOrDefault(Iterable<T> iterable) {
        Iterator it = iterable.iterator();
        return it.hasNext() ? it.next() : null;
    }

    public static <T> Iterable<T> Intersect(Iterable<T> iterable, Iterable<T> iterable2, Comparer<T> comparer) {
        return new __Extensions$$Intersect$d__7(iterable, iterable2, comparer);
    }

    public static <T, C extends Comparable<T>> Iterable<T> OrderBy(Iterable<T> iterable, Selector<T, C> selector) {
        AnonymousClass10 anonymousClass10 = new Object() {
            public Selector<T, C> aBlock;

            public int $OrderBy$b__0(T t, T t2) {
                return ((Comparable) this.aBlock.Invoke(t)).compareTo((Comparable) this.aBlock.Invoke(t2));
            }
        };
        anonymousClass10.aBlock = selector;
        Iterable ToList = ToList(iterable);
        Collections.sort(ToList, new AnonymousClass11(anonymousClass10));
        return ToList;
    }

    public static <T, C extends Comparable<T>> Iterable<T> OrderByDescending(Iterable<T> iterable, Selector<T, C> selector) {
        AnonymousClass12 anonymousClass12 = new Object() {
            public Selector<T, C> aBlock;

            public int $OrderByDescending$b__0(T t, T t2) {
                return 0 - ((Comparable) this.aBlock.Invoke(t)).compareTo((Comparable) this.aBlock.Invoke(t2));
            }
        };
        anonymousClass12.aBlock = selector;
        Iterable ToList = ToList(iterable);
        Collections.sort(ToList, new AnonymousClass13(anonymousClass12));
        return ToList;
    }

    public static <T> Iterable<T> Reverse(Iterable<T> iterable) {
        Iterable ToList = ToList(iterable);
        Collections.reverse(ToList);
        return ToList;
    }

    public static <T, R> Iterable<R> Select(Iterable<T> iterable, Selector<T, R> selector) {
        return new __Extensions$$Select$d__5(iterable, selector);
    }

    public static <T> Iterable<T> Skip(Iterable<T> iterable, int i) {
        return new __Extensions$$Skip$d__2(iterable, i);
    }

    public static <T> Iterable<T> SkipWhile(Iterable<T> iterable, Predicate<T> predicate) {
        return new __Extensions$$SkipWhile$d__4(iterable, predicate);
    }

    public static <T> Iterable<T> Take(Iterable<T> iterable, int i) {
        return new __Extensions$$Take$d__1(iterable, i);
    }

    public static <T> Iterable<T> TakeWhile(Iterable<T> iterable, Predicate<T> predicate) {
        return new __Extensions$$TakeWhile$d__3(iterable, predicate);
    }

    public static <T, K, V> Hashtable<K, V> ToDictionary(Iterable<T> iterable, Selector<T, K> selector, Selector<K, V> selector2) {
        Closeable closeable = null;
        Object obj = 1;
        Hashtable<K, V> hashtable = new Hashtable();
        if ((iterable != null ? 1 : null) != null) {
            Iterator it = iterable.iterator();
            if (it == null) {
                obj = null;
            }
            if (obj != null) {
                Throwable th;
                while (it.hasNext()) {
                    try {
                        obj = it.next();
                        hashtable.put(selector.Invoke(obj), selector2.Invoke(obj));
                    } catch (Throwable th2) {
                        th = th2;
                    }
                }
                th = null;
                if (it instanceof Closeable) {
                    if (it instanceof Closeable) {
                        closeable = (Closeable) it;
                    }
                    closeable.close();
                }
                if (th != null) {
                    throw th;
                }
            }
        }
        return hashtable;
    }

    public static <T> ArrayList<T> ToList(Iterable<T> iterable) {
        Closeable closeable = null;
        Object obj = 1;
        ArrayList<T> arrayList = new ArrayList();
        if ((iterable != null ? 1 : null) != null) {
            Iterator it = iterable.iterator();
            if (it == null) {
                obj = null;
            }
            if (obj != null) {
                Throwable th;
                while (it.hasNext()) {
                    try {
                        arrayList.add(it.next());
                    } catch (Throwable th2) {
                        th = th2;
                    }
                }
                th = null;
                if (it instanceof Closeable) {
                    if (it instanceof Closeable) {
                        closeable = (Closeable) it;
                    }
                    closeable.close();
                }
                if (th != null) {
                    throw th;
                }
            }
        }
        return arrayList;
    }

    public static <T> Iterable<T> Where(Iterable<T> iterable, Predicate<T> predicate) {
        return new __Extensions$$Where$d__0(iterable, predicate);
    }
}
