package com.remobjects.elements.system;

import java.util.AbstractList;
import java.util.ArrayList;
import java.util.concurrent.Callable;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.ThreadFactory;
import swift.Bit;

public class Task implements Runnable {
    static IThreadSyncHelper $p_ThreadSyncHelper;
    private static final ExecutorService $p_Threadpool;
    Object fAsyncState;
    Object fDelegate;
    Object fDoneHandlers;
    Throwable fException;
    Object fLock;
    int fState;

    /* renamed from: com.remobjects.elements.system.Task.10 */
    private final class AnonymousClass10 implements Runnable {
        private final C00079 arg0;

        public AnonymousClass10(C00079 c00079) {
            this.arg0 = c00079;
        }

        public final /* synthetic */ void run() {
            this.arg0.$Await$b__2();
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.2 */
    private final class C00002 {
        public Task $self;
        public Action1<Task> aAction;

        public void $ContinueWith$b__0() {
            this.aAction.run(this.$self);
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.3 */
    private final class C00013 implements Runnable {
        private final C00002 arg0;

        public C00013(C00002 c00002) {
            this.arg0 = c00002;
        }

        public final /* synthetic */ void run() {
            this.arg0.$ContinueWith$b__0();
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.4 */
    private final class C00024<T> {
        public Task $self;
        public Func2<Task, T> aAction;

        public T $ContinueWith$b__0() {
            return this.aAction.call(this.$self);
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.5 */
    private final class C00035<T> implements Callable<T> {
        private final C00024<T> arg0;

        public C00035(C00024<T> c00024) {
            this.arg0 = c00024;
        }

        public final /* synthetic */ T call() {
            return this.arg0.$ContinueWith$b__0();
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.6 */
    private final class C00046 {
        public Task $self;
        public IAwaitCompletion aCompletion;
        public Object tc;

        public void $Await$b__0(Task task) {
            this.aCompletion.moveNext(task);
        }

        public void $Await$b__1(Task task) {
            C00079 c00079 = new C00079();
            c00079.Ox$locals7 = this;
            c00079.f29a = task;
            Task.$p_ThreadSyncHelper.SyncBack(c00079.Ox$locals7.tc, new AnonymousClass10(c00079));
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.7 */
    private final class C00057 implements Action1<Task> {
        private final C00046 arg0;

        public C00057(C00046 c00046) {
            this.arg0 = c00046;
        }

        public final /* synthetic */ void run(Task task) {
            this.arg0.$Await$b__0(task);
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.8 */
    private final class C00068 implements Action1<Task> {
        private final C00046 arg0;

        public C00068(C00046 c00046) {
            this.arg0 = c00046;
        }

        public final /* synthetic */ void run(Task task) {
            this.arg0.$Await$b__1(task);
        }
    }

    /* renamed from: com.remobjects.elements.system.Task.9 */
    private final class C00079 {
        public C00046 Ox$locals7;
        public Task f29a;

        public void $Await$b__2() {
            this.Ox$locals7.aCompletion.moveNext(this.f29a);
        }
    }

    public class ThreadpoolFactory implements ThreadFactory {
        public Thread newThread(Runnable runnable) {
            Thread thread = new Thread(runnable);
            thread.setDaemon(true);
            return thread;
        }
    }

    static {
        $p_Threadpool = Executors.newCachedThreadPool(new ThreadpoolFactory());
        try {
            Class.forName("android.app.Activity");
            $p_ThreadSyncHelper = new AndroidThreadSyncHelper();
        } catch (Throwable th) {
            $p_ThreadSyncHelper = new AWTThreadSyncHelper();
        }
    }

    Task(Object obj, Object obj2) {
        this.fLock = new Object();
        this.fDelegate = obj;
        this.fAsyncState = obj2;
    }

    public Task(Runnable runnable, Object obj) {
        if ((runnable == null ? 1 : null) != null) {
            throw new IllegalArgumentException("aIn");
        }
        this((Object) runnable, obj);
    }

    public static <T> Task1<T> Run(Callable<T> callable) {
        Task task1 = new Task1((Callable) callable, null);
        task1.Start(null);
        return task1;
    }

    public static Task Run(Runnable runnable) {
        Task task = new Task(runnable, null);
        task.Start(null);
        return task;
    }

    public static IThreadSyncHelper getThreadSyncHelper() {
        return $p_ThreadSyncHelper;
    }

    public static ExecutorService getThreadpool() {
        return $p_Threadpool;
    }

    public static void setThreadSyncHelper(IThreadSyncHelper iThreadSyncHelper) {
        $p_ThreadSyncHelper = iThreadSyncHelper;
    }

    void AddOrRunContinueWith(Task task) {
        Object obj = null;
        Object obj2 = 1;
        if ((this.fState == 3 ? 1 : null) == null) {
            Throwable th;
            synchronized (this) {
                try {
                    if ((this.fState == 3 ? 1 : null) == null) {
                        if (this.fDoneHandlers != null) {
                            obj2 = null;
                        }
                        if (obj2 != null) {
                            this.fDoneHandlers = task;
                            obj2 = null;
                        } else {
                            AbstractList arrayList = new ArrayList();
                            arrayList.add(this.fDoneHandlers);
                            arrayList.add(task);
                            this.fDoneHandlers = arrayList;
                            obj2 = null;
                        }
                    }
                    obj = obj2;
                    th = null;
                } catch (Throwable th2) {
                    th = th2;
                }
            }
            if (th != null) {
                throw th;
            }
            obj2 = obj;
        }
        if (obj2 != null) {
            task.run();
        }
    }

    public boolean Await(IAwaitCompletion iAwaitCompletion) {
        boolean z = false;
        C00046 c00046 = new C00046();
        c00046.aCompletion = iAwaitCompletion;
        c00046.$self = this;
        if (getIsCompleted()) {
            return false;
        }
        c00046.tc = $p_ThreadSyncHelper.GetThreadContext();
        if (c00046.tc == null) {
            z = true;
        }
        if (z) {
            ContinueWith(new C00057(c00046), null);
        } else {
            ContinueWith(new C00068(c00046), null);
        }
        return true;
    }

    public <T> Task1<T> ContinueWith(Func2<Task, T> func2, Object obj) {
        C00024 c00024 = new C00024();
        c00024.aAction = func2;
        c00024.$self = this;
        Task task1 = new Task1(new C00035(c00024), obj);
        task1.fState = 1;
        AddOrRunContinueWith(task1);
        return task1;
    }

    public Task ContinueWith(Action1<Task> action1, Object obj) {
        C00002 c00002 = new C00002();
        c00002.aAction = action1;
        c00002.$self = this;
        Task task = new Task(new C00013(c00002), obj);
        task.fState = 1;
        AddOrRunContinueWith(task);
        return task;
    }

    void Done(Throwable th) {
        Object obj;
        Throwable th2;
        ArrayList arrayList = null;
        this.fException = th;
        synchronized (this.fLock) {
            try {
                this.fState = 3;
                obj = this.fDoneHandlers;
                try {
                    this.fDoneHandlers = null;
                    this.fLock.notifyAll();
                    th2 = null;
                } catch (Throwable th3) {
                    th2 = th3;
                }
            } catch (Throwable th4) {
                th2 = th4;
                obj = null;
            }
        }
        if (th2 != null) {
            throw th2;
        }
        if ((obj != null ? 1 : null) != null) {
            Task task = !(obj instanceof Task) ? null : (Task) obj;
            if ((task != null ? 1 : null) != null) {
                task.run();
                return;
            }
            if (obj instanceof ArrayList) {
                arrayList = (ArrayList) obj;
            }
            int size = arrayList.size() - 1;
            if ((0 <= size ? 1 : null) != null) {
                int i = size + 1;
                size = 0;
                while (true) {
                    ((Task) arrayList.get(size)).run();
                    int i2 = size + 1;
                    if (i2 != i) {
                        size = i2;
                    } else {
                        return;
                    }
                }
            }
        }
    }

    public void Start(Executor executor) {
        Object obj = 1;
        synchronized (this.fLock) {
            Throwable th = null;
            try {
                if (this.fState == 0) {
                    obj = null;
                }
                if (obj != null) {
                    throw new IllegalStateException("Task already started/queued/done");
                }
                this.fState = 1;
            } catch (Throwable th2) {
                th = th2;
            }
        }
        if (th != null) {
            throw th;
        }
        if (executor == null) {
            executor = $p_Threadpool;
        }
        executor.execute(this);
    }

    public void Wait() {
        int i;
        Object obj = 1;
        Object obj2 = null;
        if ((this.fState == 3 ? 1 : null) == null) {
            Throwable th;
            synchronized (this.fLock) {
                try {
                    if (this.fState != 3) {
                        obj = null;
                    }
                    if (obj != null) {
                        th = null;
                    } else {
                        while (this.fState != 3) {
                            this.fLock.wait();
                        }
                        i = -1;
                        th = null;
                    }
                } catch (Throwable th2) {
                    th = th2;
                    i = -1;
                }
            }
            switch (obj2) {
                case TaskState.Created /*0*/:
                default:
                    if (th != null) {
                        throw th;
                    }
            }
        }
    }

    public boolean Wait(int i) {
        boolean z = false;
        boolean z2 = true;
        if (!(this.fState == 3)) {
            Throwable th;
            synchronized (this.fLock) {
                try {
                    if (this.fState == 3) {
                        th = null;
                    } else {
                        long currentTimeMillis = System.currentTimeMillis() + ((long) i);
                        while (this.fState != 3) {
                            long currentTimeMillis2 = currentTimeMillis - System.currentTimeMillis();
                            if (currentTimeMillis2 <= 0) {
                                th = null;
                                z2 = false;
                                z = true;
                                break;
                            }
                            this.fLock.wait(currentTimeMillis2);
                        }
                        z = true;
                        th = null;
                    }
                } catch (Throwable th2) {
                    z = true;
                    th = th2;
                    z2 = false;
                }
            }
            switch (z) {
                case TaskState.Created /*0*/:
                case Bit.One /*1*/:
                case TaskState.Started /*2*/:
                    break;
                default:
                    if (th != null) {
                        throw th;
                    }
                    break;
            }
        }
        return z2;
    }

    public Object getAsyncState() {
        return this.fAsyncState;
    }

    public Throwable getException() {
        return this.fException;
    }

    public boolean getIsCompleted() {
        return this.fState == 3;
    }

    public boolean getIsFaulted() {
        return this.fException != null;
    }

    public void run() {
        Throwable th;
        Runnable runnable = null;
        synchronized (this.fLock) {
            try {
                this.fState = 2;
                th = null;
            } catch (Throwable th2) {
                th = th2;
            }
        }
        if (th != null) {
            throw th;
        }
        try {
            Object obj = this.fDelegate;
            if (obj instanceof Runnable) {
                runnable = (Runnable) obj;
            }
            runnable.run();
            Done(null);
        } catch (Throwable th3) {
            Done(th3);
        }
    }
}
