package swift;

import com.remobjects.elements.linq.Predicate;
import com.remobjects.elements.linq.Selector;
import com.remobjects.elements.linq.__Extensions;
import com.remobjects.elements.system.Func2;
import com.remobjects.elements.system.Func3;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;

public class Array<T> implements Iterable<T> {

    /* renamed from: swift.Array.1 */
    private final class C00131<T> {
        public Func3<T, T, Boolean> isOrderedBefore;

        public int $sort$b__0(T t, T t2) {
            Boolean bool = (Boolean) this.isOrderedBefore.call(t, t2);
            return bool != null ? bool.booleanValue() : false ? 1 : -1;
        }
    }

    /* renamed from: swift.Array.2 */
    private final class C00142<T> implements Comparator<T> {
        private final C00131<T> arg0;

        public C00142(C00131<T> c00131) {
            this.arg0 = c00131;
        }

        public final /* synthetic */ int compare(T t, T t2) {
            return this.arg0.$sort$b__0((Object) t, (Object) t2);
        }

        public final /* synthetic */ boolean equals(Object obj) {
            return false;
        }
    }

    /* renamed from: swift.Array.3 */
    private final class C00153<T> {
        public Func3<T, T, Boolean> isOrderedBefore;

        public int $sorted$b__0(T t, T t2) {
            Boolean bool = (Boolean) this.isOrderedBefore.call(t, t2);
            return bool != null ? bool.booleanValue() : false ? 1 : -1;
        }
    }

    /* renamed from: swift.Array.4 */
    private final class C00164<T> implements Comparator<T> {
        private final C00153<T> arg0;

        public C00164(C00153<T> c00153) {
            this.arg0 = c00153;
        }

        public final /* synthetic */ int compare(T t, T t2) {
            return this.arg0.$sorted$b__0((Object) t, (Object) t2);
        }

        public final /* synthetic */ boolean equals(Object obj) {
            return false;
        }
    }

    /* renamed from: swift.Array.5 */
    private final class C00175<T, U> {
        public Func2<T, U> transform;

        public U $map$b__0(T t) {
            return this.transform.call(t);
        }
    }

    /* renamed from: swift.Array.6 */
    private final class C00186<T, U> implements Selector<T, U> {
        private final C00175<T, U> arg0;

        public C00186(C00175<T, U> c00175) {
            this.arg0 = c00175;
        }

        public final /* synthetic */ U Invoke(T t) {
            return this.arg0.$map$b__0((Object) t);
        }
    }

    /* renamed from: swift.Array.7 */
    private final class C00197<T> {
        public Func2<T, Boolean> includeElement;

        public boolean $filter$b__0(T t) {
            Boolean bool = (Boolean) this.includeElement.call(t);
            return bool != null ? bool.booleanValue() : false;
        }
    }

    /* renamed from: swift.Array.8 */
    private final class C00208<T> implements Predicate<T> {
        private final C00197<T> arg0;

        public C00208(C00197<T> c00197) {
            this.arg0 = c00197;
        }

        public final /* synthetic */ boolean Invoke(T t) {
            return this.arg0.$filter$b__0((Object) t);
        }
    }

    public static ArrayList<T> $New() {
        return new ArrayList();
    }

    public static ArrayList<T> $New__arrayLiteral(T... tArr) {
        Object obj = 1;
        if (tArr != null) {
            if ((tArr != null ? tArr.length : 0) != 0) {
                obj = null;
            }
        }
        return obj != null ? $New() : new ArrayList(Arrays.asList(tArr));
    }

    public static ArrayList<T> $New__capacity(long j) {
        return new ArrayList((int) j);
    }

    public static ArrayList<T> $New__count__repeatedValue(long j, T t) {
        ArrayList<T> arrayList = new ArrayList((int) j);
        for (long j2 = 0; j2 < j; j2++) {
            append(arrayList, t);
        }
        return arrayList;
    }

    public static ArrayList<T> $New__items(ArrayList<T> arrayList) {
        if (arrayList != null) {
            return new ArrayList(arrayList);
        }
        throw new IllegalArgumentException("items");
    }

    public static ArrayList<T> $New__sequence(Iterable<T> iterable) {
        if (iterable != null) {
            return __Extensions.ToList(iterable);
        }
        throw new IllegalArgumentException("sequence");
    }

    public static void append(ArrayList<T> arrayList, T t) {
        arrayList.add(t);
    }

    public static boolean contains(ArrayList<T> arrayList, T t) {
        return arrayList.contains(t);
    }

    public static void extend(ArrayList<T> arrayList, Iterable<T> iterable) {
        if (iterable == null) {
            throw new IllegalArgumentException("sequence");
        }
        arrayList.addAll(__Extensions.ToList(iterable));
    }

    public static void extend(ArrayList<T> arrayList, ArrayList<T> arrayList2) {
        if (arrayList2 == null) {
            throw new IllegalArgumentException("array");
        }
        arrayList.addAll(arrayList2);
    }

    public static Iterable<T> filter(ArrayList<T> arrayList, Func2<T, Boolean> func2) {
        if (func2 == null) {
            throw new IllegalArgumentException("includeElement");
        }
        C00197 c00197 = new C00197();
        c00197.includeElement = func2;
        return __Extensions.Where(arrayList, new C00208(c00197));
    }

    public static T getItem(ArrayList<T> arrayList, long j) {
        return arrayList.get((int) j);
    }

    public static long getcapacity(ArrayList<T> arrayList) {
        return -1;
    }

    public static long getcount(ArrayList<T> arrayList) {
        return (long) arrayList.size();
    }

    public static T getfirst(ArrayList<T> arrayList) {
        return ((getcount(arrayList) > ((long) null) ? 1 : (getcount(arrayList) == ((long) null) ? 0 : -1)) > 0 ? 1 : 0) != 0 ? arrayList.get(0) : null;
    }

    public static boolean getisEmpty(ArrayList<T> arrayList) {
        return getcount(arrayList) == ((long) null);
    }

    public static T getlast(ArrayList<T> arrayList) {
        int i = 0;
        long j = getcount(arrayList);
        if (j > ((long) null)) {
            i = 1;
        }
        return i != 0 ? arrayList.get((int) (j - ((long) 1))) : null;
    }

    public static T[] getnativeArray(ArrayList<T> arrayList) {
        Object[] objArr = new Object[__Extensions.Count(arrayList)];
        Arrays.fill(objArr, null);
        return arrayList.toArray(objArr);
    }

    public static void insert__atIndex(ArrayList<T> arrayList, T t, long j) {
        arrayList.add((int) j, t);
    }

    public static Iterable<T> lazy(ArrayList<T> arrayList) {
        return arrayList;
    }

    public static <U> Iterable<U> map(ArrayList<T> arrayList, Func2<T, U> func2) {
        if (func2 == null) {
            throw new IllegalArgumentException("transform");
        }
        C00175 c00175 = new C00175();
        c00175.transform = func2;
        return __Extensions.Select(arrayList, new C00186(c00175));
    }

    public static void removeAll(ArrayList<T> arrayList, boolean z) {
        arrayList.clear();
    }

    public static T removeAtIndex(ArrayList<T> arrayList, long j) {
        return arrayList.remove((int) j);
    }

    public static T removeLast(ArrayList<T> arrayList) {
        int i = 0;
        long j = getcount(arrayList);
        if (j > ((long) null)) {
            i = 1;
        }
        if (i != 0) {
            return removeAtIndex(arrayList, j - ((long) 1));
        }
        throw new Exception("Cannot remove last item of an empty array.");
    }

    public static void reserveCapacity(ArrayList<T> arrayList, long j) {
        arrayList.ensureCapacity((int) j);
    }

    public static Iterable<T> reverse(ArrayList<T> arrayList) {
        return __Extensions.Reverse(arrayList);
    }

    public static void setItem(ArrayList<T> arrayList, long j, T t) {
        arrayList.set((int) j, t);
    }

    public static void sort(ArrayList<T> arrayList, Func3<T, T, Boolean> func3) {
        if (func3 == null) {
            throw new IllegalArgumentException("isOrderedBefore");
        }
        C00131 c00131 = new C00131();
        c00131.isOrderedBefore = func3;
        Collections.sort(arrayList, new C00142(c00131));
    }

    public static ArrayList<T> sorted(ArrayList<T> arrayList, Func3<T, T, Boolean> func3) {
        if (func3 == null) {
            throw new IllegalArgumentException("isOrderedBefore");
        }
        C00153 c00153 = new C00153();
        c00153.isOrderedBefore = func3;
        Object $New__items = $New__items(arrayList);
        Collections.sort($New__items, new C00164(c00153));
        return $New__items;
    }
}
