package swift;

import RemObjects.Elements.System.noescape;
import com.remobjects.elements.system.Func1;
import com.remobjects.elements.system.Func2;
import com.remobjects.elements.system.ValueTypeParameter;
import com.remobjects.elements.system.VarParameter;
import java.io.Closeable;
import java.util.Iterator;

public class __Extension_String {

    public abstract class CharacterView {
        CharacterView(String str) {
            if (str == null) {
                throw new IllegalArgumentException("string");
            }
        }

        public abstract long getendIndex();

        public long getstartIndex() {
            return 0;
        }
    }

    public class UTF16CharacterView extends CharacterView implements ICustomDebugStringConvertible {
        private final String $p_string;

        UTF16CharacterView(String str) {
            if (str == null) {
                throw new IllegalArgumentException("string");
            }
            super(str);
            this.$p_string = str;
        }

        public char getItem(long j) {
            return (char) this.$p_string.charAt((int) j);
        }

        public String getdebugDescription() {
            Closeable closeable = null;
            String str = "UTF16CharacterView(";
            Iterable GetSequence = __Extension_Int64.op_DotDotLt(getstartIndex(), getendIndex()).GetSequence();
            if ((GetSequence != null ? 1 : null) != null) {
                Iterator it = GetSequence.iterator();
                if ((it != null ? 1 : null) != null) {
                    String str2 = str;
                    while (it.hasNext()) {
                        try {
                            Long l = (Long) it.next();
                            Object obj = l != null ? l.longValue() > getstartIndex() ? 1 : null : null;
                            if (obj != null) {
                                str2 = str2 == null ? " " : str2.concat(" ");
                            }
                            String toHexString = __Extension_UInt64.toHexString((long) getItem(l != null ? l.longValue() : 0), 4);
                            if (str2 != null) {
                                toHexString = toHexString == null ? str2 : str2.concat(toHexString);
                            }
                            str2 = toHexString;
                        } catch (Throwable th) {
                            str = str2;
                            Object obj2 = th;
                        }
                    }
                    str = str2;
                    Closeable closeable2 = null;
                    if (it instanceof Closeable) {
                        if (it instanceof Closeable) {
                            closeable = (Closeable) it;
                        }
                        closeable.close();
                    }
                    if (closeable2 != null) {
                        throw closeable2;
                    }
                }
            }
            return str == null ? ")" : str.concat(")");
        }

        public long getendIndex() {
            return __Extension_String.length(this.$p_string);
        }

        String getstring() {
            return this.$p_string;
        }
    }

    public class UTF32CharacterView extends CharacterView implements ICustomDebugStringConvertible {
        private final byte[] $p_stringData;

        /* renamed from: swift.__Extension_String.UTF32CharacterView.1 */
        private final class C00231 implements Func1<String> {
            public final /* synthetic */ String call() {
                return UTF32CharacterView.$$init$$b__0();
            }
        }

        static String $$init$$b__0() {
            return "UTF32CharacterView is not implemenyted for Java yet.";
        }

        UTF32CharacterView(String str) {
            if (str == null) {
                throw new IllegalArgumentException("string");
            }
            super(str);
            this.$p_stringData = new byte[0];
            __Global.fatalError__file__line(new C00231(), "c:\\CI\\b\\elements\\932\\Source\\SwiftBaseLibrary\\Source\\StringExtensions.swift", 300);
        }

        public int getItem(long j) {
            return (((this.$p_stringData[(int) (((long) 4) * j)] & 255) + ((this.$p_stringData[(int) ((((long) 4) * j) + ((long) 1))] & 255) << 8)) + ((this.$p_stringData[(int) ((((long) 4) * j) + ((long) 2))] & 255) << 16)) + ((this.$p_stringData[(int) ((((long) 4) * j) + ((long) 3))] & 255) << 24);
        }

        public String getdebugDescription() {
            Closeable closeable = null;
            String str = "UTF32CharacterView(";
            Iterable GetSequence = __Extension_Int64.op_DotDotLt(getstartIndex(), getendIndex()).GetSequence();
            if ((GetSequence != null ? 1 : null) != null) {
                Iterator it = GetSequence.iterator();
                if ((it != null ? 1 : null) != null) {
                    String str2 = str;
                    while (it.hasNext()) {
                        try {
                            Long l = (Long) it.next();
                            Object obj = l != null ? l.longValue() > getstartIndex() ? 1 : null : null;
                            if (obj != null) {
                                str2 = str2 == null ? " " : str2.concat(" ");
                            }
                            String toHexString = __Extension_UInt64.toHexString(((long) getItem(l != null ? l.longValue() : 0)) & 4294967295L, 8);
                            if (str2 != null) {
                                toHexString = toHexString == null ? str2 : str2.concat(toHexString);
                            }
                            str2 = toHexString;
                        } catch (Throwable th) {
                            str = str2;
                            Object obj2 = th;
                        }
                    }
                    str = str2;
                    Closeable closeable2 = null;
                    if (it instanceof Closeable) {
                        if (it instanceof Closeable) {
                            closeable = (Closeable) it;
                        }
                        closeable.close();
                    }
                    if (closeable2 != null) {
                        throw closeable2;
                    }
                }
            }
            return str == null ? ")" : str.concat(")");
        }

        public long getendIndex() {
            byte[] bArr = this.$p_stringData;
            return (long) ((bArr != null ? bArr.length : 0) / 4);
        }

        byte[] getstringData() {
            return this.$p_stringData;
        }
    }

    public class UTF8CharacterView extends CharacterView implements ICustomDebugStringConvertible {
        private final byte[] $p_stringData;

        /* renamed from: swift.__Extension_String.UTF8CharacterView.1 */
        private final class C00241 implements Func1<String> {
            public final /* synthetic */ String call() {
                return UTF8CharacterView.$$init$$b__0();
            }
        }

        static String $$init$$b__0() {
            return "UTF8CharacterView is not implemenyted for Java yet.";
        }

        UTF8CharacterView(String str) {
            if (str == null) {
                throw new IllegalArgumentException("string");
            }
            super(str);
            this.$p_stringData = new byte[0];
            __Global.fatalError__file__line(new C00241(), "c:\\CI\\b\\elements\\932\\Source\\SwiftBaseLibrary\\Source\\StringExtensions.swift", 343);
        }

        public byte getItem(long j) {
            return (byte) (this.$p_stringData[(int) j] & 255);
        }

        public String getdebugDescription() {
            Closeable closeable = null;
            String str = "UTF8CharacterView(";
            Iterable GetSequence = __Extension_Int64.op_DotDotLt(getstartIndex(), getendIndex()).GetSequence();
            if ((GetSequence != null ? 1 : null) != null) {
                Iterator it = GetSequence.iterator();
                if ((it != null ? 1 : null) != null) {
                    String str2 = str;
                    while (it.hasNext()) {
                        try {
                            Long l = (Long) it.next();
                            Object obj = l != null ? l.longValue() > getstartIndex() ? 1 : null : null;
                            if (obj != null) {
                                str2 = str2 == null ? " " : str2.concat(" ");
                            }
                            String toHexString = __Extension_UInt64.toHexString((long) getItem(l != null ? l.longValue() : 0), 2);
                            if (str2 != null) {
                                toHexString = toHexString == null ? str2 : str2.concat(toHexString);
                            }
                            str2 = toHexString;
                        } catch (Throwable th) {
                            str = str2;
                            Object obj2 = th;
                        }
                    }
                    str = str2;
                    Closeable closeable2 = null;
                    if (it instanceof Closeable) {
                        if (it instanceof Closeable) {
                            closeable = (Closeable) it;
                        }
                        closeable.close();
                    }
                    if (closeable2 != null) {
                        throw closeable2;
                    }
                }
            }
            return str == null ? ")" : str.concat(")");
        }

        public long getendIndex() {
            byte[] bArr = this.$p_stringData;
            return (long) (bArr != null ? bArr.length : 0);
        }

        byte[] getstringData() {
            return this.$p_stringData;
        }
    }

    public static String $New__count__repeatedValue(long j, char c) {
        char[] cArr = new char[((int) j)];
        for (long j2 = 0; j2 < j; j2++) {
            cArr[(int) j2] = c;
        }
        return new String(cArr);
    }

    public static String $New__reflecting(Object obj) {
        ICustomStringConvertible iCustomStringConvertible = null;
        if (obj == null) {
            throw new IllegalArgumentException("subject");
        }
        ICustomDebugStringConvertible iCustomDebugStringConvertible = !(obj instanceof ICustomDebugStringConvertible) ? null : (ICustomDebugStringConvertible) obj;
        if ((iCustomDebugStringConvertible != null ? 1 : null) != null) {
            return iCustomDebugStringConvertible.getdebugDescription();
        }
        if (obj instanceof ICustomStringConvertible) {
            iCustomStringConvertible = (ICustomStringConvertible) obj;
        }
        return (iCustomStringConvertible != null ? 1 : null) != null ? iCustomStringConvertible.getdescription() : obj.toString();
    }

    public static String getItem(String str, Range range) {
        if (range != null) {
            return str.substring((int) range.getstartIndex(), (int) range.getlength());
        }
        throw new IllegalArgumentException("range");
    }

    public static UTF16CharacterView getcharacters(String str) {
        return new UTF16CharacterView(str);
    }

    public static String getdebugDescription(String str) {
        return str;
    }

    public static long getendIndex(String str) {
        return (long) str.length();
    }

    public static long gethashValue(String str) {
        return (long) str.hashCode();
    }

    public static boolean getisEmpty(String str) {
        return str.length() == 0;
    }

    public static String getlowercaseString(String str) {
        return str.toLowerCase();
    }

    public static long getstartIndex(String str) {
        return 0;
    }

    public static UTF32CharacterView getunicodeScalars(String str) {
        return new UTF32CharacterView(str);
    }

    public static String getuppercaseString(String str) {
        return str.toUpperCase();
    }

    public static UTF16CharacterView getutf16(String str) {
        return new UTF16CharacterView(str);
    }

    public static UTF8CharacterView getutf8(String str) {
        return new UTF8CharacterView(str);
    }

    public static boolean hasPrefix(String str, String str2) {
        if (str2 != null) {
            return str.startsWith(str2);
        }
        throw new IllegalArgumentException("prefix");
    }

    public static boolean hasSuffix(String str, String str2) {
        if (str2 != null) {
            return str.endsWith(str2);
        }
        throw new IllegalArgumentException("suffix");
    }

    public static long length(String str) {
        return (long) str.length();
    }

    public static Long toInt(String str) {
        try {
            return Long.valueOf((long) Integer.parseInt(str));
        } catch (NumberFormatException e) {
            return null;
        }
    }

    public static <R> R withUTF8Buffer(String str, @noescape Func2<byte[], R> func2) {
        if (func2 != null) {
            return func2.call(getutf8(str).getstringData());
        }
        throw new IllegalArgumentException("body");
    }

    static <Target extends IOutputStreamType> void writeTo(String str, @ValueTypeParameter VarParameter<Target> varParameter) {
    }
}
